function error(txt)
{
	print "Error:", txt
	err++
}

function check(suffix)
{
	sub("^ *", "", text1)
	sub("^ *", "", bin)
	sub("^ *", "", text2)
	sub("^ *", "", res)
	if (length(bin) != 24)
		error("binary length should be 24 but is " length(bin))
	if (text1 != text2)
		error("text versions mismatch")
	if (res != "0")
		error("cmp failed")
	if (substr(bin, 24, 1) != suffix)
		error("Bin key suffix (counter) should be " suffix " but is " substr(bin, 24, 1))
}

BEGIN {
	err = 0

	getline text1
	getline bin
	getline text2
	getline res
	check("B")

	getline

	getline text1
	getline bin
	getline text2
	getline res
	check("C")

	if (err > 0)
		exit 1
}
